include \masm32\include\masm32rt.inc
.686p
.mmx
.xmm

WndProc proto hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

PHBITMAP typedef ptr HBITMAP

.data?
	hInstance	HINSTANCE 	?
	phBmp		PHBITMAP 	?
	nBmps		DWORD		?
.code
main proc 
LOCAL wcex:WNDCLASSEX
LOCAL msg:MSG

	mov hInstance,rv(GetModuleHandle,0)
	mov wcex.hInstance,eax
	mov wcex.cbSize,SIZEOF WNDCLASSEX
	mov wcex.style, CS_HREDRAW or CS_VREDRAW
	mov wcex.lpfnWndProc, OFFSET WndProc
	mov wcex.cbClsExtra,NULL
	mov wcex.cbWndExtra,0
	mov wcex.hbrBackground,rv(GetStockObject,BLACK_BRUSH)
	mov wcex.lpszMenuName,NULL
	mov wcex.lpszClassName,chr$("win32class")
	mov wcex.hIcon,rv(LoadIcon,NULL,IDI_APPLICATION)
	mov wcex.hIconSm,eax
	mov wcex.hCursor,rv(LoadCursor,NULL,IDC_ARROW)
	invoke RegisterClassEx, ADDR wcex
	mov esi,rv(CreateWindowEx,0,wcex.lpszClassName,"Win32App",WS_VISIBLE or WS_SYSMENU or WS_SIZEBOX or WS_MINIMIZEBOX or WS_MAXIMIZEBOX or WS_CLIPCHILDREN,CW_USEDEFAULT,CW_USEDEFAULT,350,150,0,0,hInstance,0)

	.while 1
		invoke GetMessage,ADDR msg,NULL,0,0
		.break .if !eax || eax == -1
		invoke TranslateMessage, ADDR msg
		invoke DispatchMessage, ADDR msg
	.endw

	invoke ExitProcess,msg.wParam

main endp

; input:  hBitmap = image-strip
;         ny = height of sub-image
; return: eax = pointer to handle array (use hfree-macro for deletion)
;               or zero, if fail.
;         ecx = number of handels
;         LOWORD(edx) = bitmap width , HIGHWORD(edx) = bitmap height
SplitVert proc uses edi esi ebx hBitmap:HBITMAP,ny:DWORD
LOCAL bmp:BITMAP
LOCAL hDC:HDC
LOCAL hSrcDC:HDC
LOCAL hDestDC:HDC
LOCAL hBmpOrg1:HANDLE
LOCAL hBmpOrg2:HANDLE
LOCAL n:DWORD

;/* get bitmap width and height */
.if rv(GetObject,hBitmap,SIZEOF bmp,ADDR bmp)

;/* calcualte number of sub-images */
xor edx,edx
mov eax,bmp.bmHeight
mov ecx,ny
div ecx
.if eax
mov n,eax
lea eax,[eax*4]
mov edi,halloc(eax) ; allocate handle-array

;/* create DCs */
mov hDC,rv(GetDC,rv(GetDesktopWindow)) ; reference-DC
mov hSrcDC,rv(CreateCompatibleDC,hDC)
mov hDestDC,rv(CreateCompatibleDC,hDC)

;/* select bitmap and save privious */
mov hBmpOrg1,rv(SelectObject,hSrcDC,hBitmap)

xor esi,esi
xor ebx,ebx
.while esi < n
;/* create bitmap and select it into DC. Also save privious handle */
mov hBmpOrg2,rv(SelectObject,hDestDC,rv(CreateCompatibleBitmap,hDC,bmp.bmWidth,ny))

;/* copy image */
invoke BitBlt,hDestDC,0,0,bmp.bmWidth,ny,hSrcDC,0,ebx,SRCCOPY

;/* reload orginal bitmap and save the returned one */
mov [edi+esi*4],rv(SelectObject,hDestDC,hBmpOrg2)

add esi,1
add ebx,ny
.endw

invoke ReleaseDC,rv(GetDesktopWindow),hDC

;/* restore orginal bitmaps and delete the created one */
invoke DeleteObject,rv(SelectObject,hSrcDC,hBmpOrg1)

;/* delete DCs */
invoke DeleteDC,hSrcDC
invoke DeleteDC,hDestDC

mov eax,edi
mov ecx,bmp.bmHeight
mov edx,bmp.bmHeight
shl edx,16
mov dx,cx
mov ecx,n
.endif
.endif
ret

SplitVert endp

WndProc proc uses ebx esi edi hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
LOCAL hBmp:HBITMAP
LOCAL nx:DWORD
LOCAL ny:DWORD

	.if uMsg == WM_CLOSE
		invoke PostQuitMessage,NULL
	.elseif uMsg == WM_DESTROY
		mov ebx,phBmp
		xor esi,esi
		.while esi < nBmps
			invoke DeleteObject,HBITMAP ptr [ebx+esi*4]
			inc esi
		.endw
		hfree phBmp
	.elseif uMsg == WM_CREATE
		mov hBmp,rv(LoadImage,0,"Exit.bmp",IMAGE_BITMAP,0,0,LR_DEFAULTSIZE or LR_LOADFROMFILE)
		.if hBmp
			mov phBmp,rv(SplitVert,hBmp,16+6)
			.if phBmp
				mov nBmps,ecx
				movzx eax,dx
				mov nx,eax
				shr edx,16
				mov ny,edx
				
				mov edi,phBmp
				xor esi,esi
				xor ebx,ebx
				.while esi < nBmps
					
					fn CreateWindowEx,0,"static",0,SS_BITMAP or WS_CHILD or WS_VISIBLE,ebx,10,nx,ny,hWnd,0,hInstance,0
					invoke SendMessage,eax,STM_SETIMAGE,IMAGE_BITMAP,HBITMAP ptr [edi+esi*4]
					
					add ebx,nx
					lea esi,[esi+1]
				.endw
				invoke DeleteObject,hBmp
			.else
				invoke DeleteObject,hBmp
				invoke MessageBeep,MB_ICONEXCLAMATION
				exit
			.endif
		.else
			invoke MessageBeep,MB_ICONEXCLAMATION
			exit
		.endif
	.else
		invoke DefWindowProc,hWnd,uMsg,wParam,lParam
		ret
	.endif

	xor eax,eax
	ret
WndProc endp
end main